package imt;

import java.util.List;
import java.util.Optional;
import java.util.Set;

import lombok.Data;

@Data
public class Concours {
	private final Jury jury1;
	private final Jury jury2;
	private final Jury jury3;
	private final Set<Proposition> propositions; // minimun 5

	public Concours(Jury jury1, Jury jury2, Jury jury3, Set<Proposition> propositions) {
		this.jury1 = jury1;
		this.jury2 = jury2;
		this.jury3 = jury3;

		for (Proposition proposition : propositions) {
			if (proposition.getChef().getPlats().contains(proposition.getPlatPropose()) == false) {
				throw new IllegalArgumentException();
			}
		}

		if (propositions.size() != 5) {
			throw new IllegalArgumentException();
		} else {
			this.propositions = propositions;
		}
	}

	public boolean estTermine() {
		return propositions.stream()
				.allMatch(proposition -> proposition.getNote().isPresent());
	}

	public void noter(Proposition proposition, int note) {
		for (Proposition propositionLoop : propositions) {
			if (propositionLoop.equals(proposition)) {
				propositionLoop.setNote(Optional.of(note));
			}
		}
	}

	public List<Proposition> classement() {
		return getPropositions().stream().sorted((left, right) -> {
			if (left.getNote().isEmpty()) {
				return +1;
			} else if (right.getNote().isEmpty()) {
				return -1;
			} else {
				return left.getNote().get().compareTo(right.getNote().get());
			}
		})
		.toList();
	}
}
